/*
* This file is part of project OpenEmbroidery. It's copyrighted by
* the contributors recorded in the version control history of the file.
* Original project location https://code.electrolab.fr/openEmbroidery/openEmbroidery_software
*
* SPDX-License-Identifier: CECILL-2.1
* License-Filename: Licence_CeCILL_V2.1-en.txt
*/

#pragma once

#include "stitchs/OE_birailstitch.h"
#include "actions/OE_actions.h"

class OE_actionNewBirailStitch : public OE_actions
{
	public:
		OE_actionNewBirailStitch(OE_document* doc, bool reverse1, bool reverse2, float offset1, float offset2, float len);

		virtual ~OE_actionNewBirailStitch();

		virtual void undo();
		virtual void redo();

	protected:
		OE_actions* action;
};

class OE_actionSetBirailStitchLen : public OE_actions
{
	public:
		OE_actionSetBirailStitchLen(OE_document* doc, OE_birailstitch* stitch, float len);

		virtual ~OE_actionSetBirailStitchLen();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldLen;
};

class OE_actionSetBirailStitchOffset1 : public OE_actions
{
	public:
		OE_actionSetBirailStitchOffset1(OE_document* doc, OE_birailstitch* stitch, float offset);

		virtual ~OE_actionSetBirailStitchOffset1();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldOffset;
};

class OE_actionSetBirailStitchOffset2 : public OE_actions
{
	public:
		OE_actionSetBirailStitchOffset2(OE_document* doc, OE_birailstitch* stitch, float offset);

		virtual ~OE_actionSetBirailStitchOffset2();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldOffset;
};

class OE_actionScaleSelectedBirailStitchLen : public OE_actions
{
	public:
		OE_actionScaleSelectedBirailStitchLen(OE_document* doc, float scale);

		virtual ~OE_actionScaleSelectedBirailStitchLen();

		virtual void undo();
		virtual void redo();

		void scaleLen(float scale);

	protected:
		std::list<OE_actionSetBirailStitchLen*> actions;
};

